commit f400d065a2ecda19b46fc0f7ec0a1fe6d7dd597e
Author: Nathaniel Shead <nathanieloshead@gmail.com>
Date:   Fri Dec 20 22:09:39 2024 +1100

    c++: Allow pragmas in NSDMIs [PR118147]
    
    This patch removes the (unnecessary) CPP_PRAGMA_EOL case from
    cp_parser_cache_defarg, which currently has the result that any pragmas
    in the NSDMI cause an error.
    
            PR c++/118147
    
    gcc/cp/ChangeLog:
    
            * parser.cc (cp_parser_cache_defarg): Don't error when
            CPP_PRAGMA_EOL.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/nsdmi-defer7.C: New test.
    
    Signed-off-by: Nathaniel Shead <nathanieloshead@gmail.com>
    (cherry picked from commit f3ccc57e5f044031a1b07e79330de9220e93afe7)

diff --git a/gcc/cp/parser.cc b/gcc/cp/parser.cc
index 725b5ef4ad6..5bfbdf85f15 100644
--- a/gcc/cp/parser.cc
+++ b/gcc/cp/parser.cc
@@ -35674,7 +35674,6 @@ cp_parser_cache_defarg (cp_parser *parser, bool nsdmi)
 
 	  /* If we run out of tokens, issue an error message.  */
 	case CPP_EOF:
-	case CPP_PRAGMA_EOL:
 	  error_at (token->location, "file ends in default argument");
 	  return error_mark_node;
 
diff --git a/gcc/testsuite/g++.dg/cpp0x/nsdmi-defer7.C b/gcc/testsuite/g++.dg/cpp0x/nsdmi-defer7.C
new file mode 100644
index 00000000000..3bef636ccbd
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/nsdmi-defer7.C
@@ -0,0 +1,13 @@
+// PR c++/118147
+// { dg-do compile { target c++11 } }
+
+struct F {
+  int i = []{
+    #pragma message "test"  // { dg-message "test" }
+    return 1;
+  }();
+};
+
+struct G {
+  int i =
+    #pragma GCC diagnostic push  // { dg-error "file ends in default argument|expected" }

